pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT > Class Template Reference
Module geometry

Circulates clockwise around a face and returns an index to the outer half-edge (the target). More...

`#include <pcl/geometry/mesh_circulators.h>`

Inheritance diagram for pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >:

## Public Types

typedef boost::equality_comparable< pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >, boost::unit_steppable< pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT > > > | Base
typedef pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT > | Self
typedef MeshT | Mesh
typedef Mesh::FaceIndex | FaceIndex
typedef Mesh::HalfEdgeIndex | HalfEdgeIndex

## Public Member Functions

| OuterHalfEdgeAroundFaceCirculator ()
| Constructor resulting in an invalid circulator. More...
| OuterHalfEdgeAroundFaceCirculator (const FaceIndex &idx_face, Mesh *const mesh)
| Construct from the face around which we want to circulate. More...
| OuterHalfEdgeAroundFaceCirculator (const HalfEdgeIndex &idx_inner_half_edge, Mesh *const mesh)
| Construct directly from the inner half-edge. More...
bool | isValid () const
| Check if the circulator is valid. More...
bool | operator== (const Self &other) const
| Comparison operators (with boost::operators): == !=. More...
Self & | operator++ ()
| Increment operators (with boost::operators): ++ (pre and post) More...
Self & | operator-- ()
| Decrement operators (with boost::operators): – (pre and post) More...
HalfEdgeIndex | getTargetIndex () const
| Get the index to the outer half-edge. More...
HalfEdgeIndex | getCurrentHalfEdgeIndex () const
| Get the half-edge that is currently stored in the circulator. More...

## Public Attributes

Mesh * | mesh_
| The mesh to which this circulator belongs to. More...
HalfEdgeIndex | idx_inner_half_edge_
| The inner half-edge of the face around which we want to circulate. More...

## Detailed Description

### template<class MeshT>
class pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >

Circulates clockwise around a face and returns an index to the outer half-edge (the target).

The best way to declare the circulator is to use the method pcl::geometry::MeshBase::getOuterHalfEdgeAroundFaceCirculator ().

Template Parameters

  MeshT | Mesh to which this circulator belongs to.

Note
  The circulator can't be used to change the connectivity in the mesh (only const circulators are valid).

Author
  Martin Saelzle

Definition at line 714 of file mesh_circulators.h.

## Member Typedef Documentation

## Base

template<class MeshT >

typedef boost::equality_comparable<pcl::geometry::OuterHalfEdgeAroundFaceCirculator <MeshT> , boost::unit_steppable <pcl::geometry::OuterHalfEdgeAroundFaceCirculator <MeshT> > > pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::Base

Definition at line 722 of file mesh_circulators.h.

## FaceIndex

template<class MeshT >

typedef Mesh::FaceIndex pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::FaceIndex

Definition at line 726 of file mesh_circulators.h.

## HalfEdgeIndex

template<class MeshT >

typedef Mesh::HalfEdgeIndex pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::HalfEdgeIndex

Definition at line 727 of file mesh_circulators.h.

## Mesh

template<class MeshT >

typedef MeshT pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::Mesh

Definition at line 725 of file mesh_circulators.h.

## Self

template<class MeshT >

typedef pcl::geometry::OuterHalfEdgeAroundFaceCirculator<MeshT> pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::Self

Definition at line 723 of file mesh_circulators.h.

## Constructor & Destructor Documentation

## OuterHalfEdgeAroundFaceCirculator() [1/3]

template<class MeshT >

pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::OuterHalfEdgeAroundFaceCirculator | ( |  | ) |

inline

Constructor resulting in an invalid circulator.

Definition at line 730 of file mesh_circulators.h.

## OuterHalfEdgeAroundFaceCirculator() [2/3]

template<class MeshT >

pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::OuterHalfEdgeAroundFaceCirculator | ( | const FaceIndex & | idx_face,
|  | Mesh *const | mesh
| ) |  |

inline

Construct from the face around which we want to circulate.

Definition at line 737 of file mesh_circulators.h.

## OuterHalfEdgeAroundFaceCirculator() [3/3]

template<class MeshT >

pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::OuterHalfEdgeAroundFaceCirculator | ( | const HalfEdgeIndex & | idx_inner_half_edge,
|  | Mesh *const | mesh
| ) |  |

inline

Construct directly from the inner half-edge.

Definition at line 745 of file mesh_circulators.h.

## Member Function Documentation

## getCurrentHalfEdgeIndex()

template<class MeshT >

HalfEdgeIndex pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::getCurrentHalfEdgeIndex | ( |  | ) | const

inline

Get the half-edge that is currently stored in the circulator.

Definition at line 793 of file mesh_circulators.h.

## getTargetIndex()

template<class MeshT >

HalfEdgeIndex pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::getTargetIndex | ( |  | ) | const

inline

Get the index to the outer half-edge.

Definition at line 786 of file mesh_circulators.h.

References pcl::geometry::VertexAroundVertexCirculator< MeshT >::mesh_.

Referenced by pcl::geometry::MeshBase< QuadMesh< MeshTraitsT >, MeshTraitsT, QuadMeshTag >::isBoundary().

## isValid()

template<class MeshT >

bool pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::isValid | ( |  | ) | const

inline

Check if the circulator is valid.

Warning
  Does NOT check if the stored mesh pointer is valid. You have to ensure this yourself when constructing the circulator.

Definition at line 755 of file mesh_circulators.h.

## operator++()

template<class MeshT >

Self& pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::operator++ | ( |  | ) |

inline

Increment operators (with boost::operators): ++ (pre and post)

Definition at line 770 of file mesh_circulators.h.

References pcl::geometry::VertexAroundVertexCirculator< MeshT >::mesh_.

## operator--()

template<class MeshT >

Self& pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::operator-- | ( |  | ) |

inline

Decrement operators (with boost::operators): – (pre and post)

Definition at line 778 of file mesh_circulators.h.

References pcl::geometry::VertexAroundVertexCirculator< MeshT >::mesh_.

## operator==()

template<class MeshT >

bool pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::operator== | ( | const Self & | other | ) | const

inline

Comparison operators (with boost::operators): == !=.

Warning
  Does NOT check if the circulators belong to the same mesh. Please check this yourself.

Definition at line 763 of file mesh_circulators.h.

References pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::idx_inner_half_edge_.

## Member Data Documentation

## idx_inner_half_edge_

template<class MeshT >

HalfEdgeIndex pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::idx_inner_half_edge_

The inner half-edge of the face around which we want to circulate.

Definition at line 802 of file mesh_circulators.h.

Referenced by pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::operator==().

## mesh_

template<class MeshT >

Mesh* pcl::geometry::OuterHalfEdgeAroundFaceCirculator< MeshT >::mesh_

The mesh to which this circulator belongs to.

Definition at line 799 of file mesh_circulators.h.

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/geometry/include/pcl/geometry/mesh_circulators.h